<template>
   <div class="msgVerify">
    <section class="wrapper">
      <!--表單   -->
      <div class="form">
        <div class="form_b">
          <ul class="step">
            <li class="step_item">手机号码</li>
            <li class="step_item step--active">
              短信验证
              <div class="before"></div>
            </li>
            <li class="step_item">填写基本资料</li>
            <li class="step_item">绑定完成</li>
          </ul>
          <section class="ten_b"><span class="remind" style="visibility: hidden">*为必填字段</span></section>
          <section class="ten_b"><span class="ten_b_itemsName">验证码 </span>
            <section class="ten_b_content">
              <input class="content_enter w_10" type="text" :value="verifycode" name="enter" placeholder="请输入验证码" id="code" @input="code($event)">
              <label id ="phoneNum-error" class="error" v-if="errorshow">验证码有误，请重新输入！</label>
            </section>
          </section>
          <section class="ten_b mgt_24">
            <a class="btn sendVer-js" href="#" @click="send">
            <div >{{sendCode}}</div>
            </a>
          </section>

        </div>
        <div class="form_b">
          <section class="ten_b ten_b_verText">
            <p>收不到验证短信吗？</p>
            <p>请点选菜单上【在线客服】</p>
          </section>
          <section class="ten_b btn_b">
            <button class="btn"  id="submit" @click="verify">送出验证码</button>
          </section>
        </div>
      </div>
    </section>
     <section class="pop" style ="display: block;" v-if="popshow">
       <section class="pop_content">
         <div class="pop_close" @click="close"><span></span><span></span></div>
         <div id="content">
           <div >
             <div class="confirmInfo mgt_24">
               <span class="confirmNum"></span><strong></strong></div>
             <div class="confirmInfo mgt_12 mgb_24">
               <span class="confirmName"></span><strong></strong></div>
             <div class="pop_info">
               <p>抱歉由于简讯验证码输入错误达3次以上，您的注册功能已被暂时锁定，并将于[<span>{{newtime}}</span>]解除锁定。如您有需要协助之处，请点选菜单上的在线客服，谢谢。</p>
             </div>
           </div>
         </div>
         <div class="pop_confirmBox" >
           <button class="confirm_no" @click="back">确定</button>
         </div>
       </section>
     </section>
     <!--<v-hintbox :hintbox="hintbox" @close="close"></v-hintbox>-->
   </div>
</template>
<script>
    import store from  '../../utils/store.js';
    import hintbox from  '@/components/hintbox/hintbox.vue';
export default {
    data(){
        return{
                isSendSMS:'',//手机发送短信是否被禁用
                newtime:'',//手机验证码的过期时间
                hintbox:'',
                sendCode:'重新发送验证码',
                errorshow:false,
                verifycode:'',
                timer:'',
                popshow:false,
        }
    },
    components:{
        // "v-hintbox" : hintbox,
    },
    // computed:{
    //     sendTimer();
    // },
    methods:{
        code(data){
            this.verifycode = data.target.value;
            console.log('验证码',this.verifycode);
        },
        close(){
            this.popshow = false;
            wx.closeWindow();
            this.$forceUpdate();
        },
        back(){
            this.popshow = false;
            wx.closeWindow();
        },
        //重新发送验证码事件
        send(){
            let that = this;
            this.sendTimer();
            let date = new Date();
            let year = date.getFullYear();
            let month = date.getMonth()+1;
            let day = date.getDate();
            let hour = date.getHours();
            let minute = date.getMinutes();
            let second = date.getSeconds();
            let newhour = hour +8;
            // that.newtime = year+'/'+month+'/'+day+'/'+newhour+':'+minute+':'+second;
            console.log('当前时间',year+'/'+month+'/'+day+'/'+hour+':'+minute+':'+second);
            console.log('8小时之后的时间',year+'/'+month+'/'+day+'/'+newhour+':'+minute+':'+second);
            if(store.state.msgVerify.register.type === 'old'){
                if(that.isSendSMS){
                    this.sendMsg();
                }else{
                    this.sendCode = '重新发送验证码';
                    this.popshow = true;
                }

            }else{
                if(that.isSendSMS){
                    this.getCode();
                }else{
                    this.sendCode = '重新发送验证码';
                    this.popshow = true;
                }
            }
        },
        //后端校验验证码接口
        verify(){
            let that = this;
            console.log('输入验证码',this.verifycode);
            if(this.verifycode === ''){
                this.errorshow = true;
                this.verifycode = '';
                return;
            }
            let data={
                openId:context.OpenId,
                verCode:this.verifycode
            };
            console.log('data',data);
            this.config.server(
                "/Check/VerCode",
                "POST",
                data,
                (data)=> {
                    console.log('data',data);
                    if(data.records[0].isThirdError){
                        let date = new Date();
                        let year = date.getFullYear();
                        let month = date.getMonth()+1;
                        let day = date.getDate();
                        let hour = date.getHours();
                        let minute = date.getMinutes();
                        let second = date.getSeconds();
                        let newhour = hour +8;
                        that.newtime = year+'/'+month+'/'+day+'/'+newhour+':'+minute+':'+second;
                        console.log('当前时间',year+'/'+month+'/'+day+'/'+hour+':'+minute+':'+second);
                        console.log('8小时之后的时间',year+'/'+month+'/'+day+'/'+newhour+':'+minute+':'+second);
                        // clearInterval(this.timer);
                        // this.timer = null;
                        this.sendCode = '重新发送验证码';
                        this.popshow = true;
                        this.$forceUpdate();
                        return;
                    }
                    if(data.records[0].isCorrect){
                        let data1 = {
                            phoneNum:store.state.msgVerify.register.phoneNum,
                            areaCode:store.state.msgVerify.register.areaCode,
                            type:store.state.msgVerify.register.type,
                            contactId:store.state.msgVerify.register.contactId
                        }
                        console.log('msg',data1);
                        store.commit('setData',['personInfo','verify',data1])
                        this.$router.replace('/personInfo');
                        sessionStorage.setItem('page','personInfo')
                    }else{
                        this.errorshow = true;
                        this.verifycode = '';
                    }
                    this.$forceUpdate();
                },
                (error)=> {
                    console.log('error',error);
                },
            )
        },
        //新用户注册获取验证码
        getCode(){
            let that = this;
            let data = {
                openId:context.OpenId,
                phoneNum:store.state.msgVerify.register.phoneNum,
                areaCode: store.state.msgVerify.register.areaCode
            };
            console.log('data',data);
            this.config.server(
                "/User/CheckPhone",
                "POST",
                data,
                (data)=> {
                    console.log('success',data);
                    console.log(data);
                    that.isSendSMS = data.records[0].isSendSMS;
                    if(!that.isSendSMS){
                        that.popshow = true;
                        that.newtime = data.records[0].lockTime;
                        clearInterval(this.timer);
                        this.timer = null;
                        this.sendCode = '重新发送验证码';
                    }
                    this.$forceUpdate();

                },
                (error)=> {
                    console.log('error',error);
                },
            )
        },
        //发送短信定时器
        sendTimer(){
            let time = 120;
            this.timer = setInterval(() => {
                time--;
                if (time < 0) {
                    time = '';
                    this.sendCode = '重新发送验证码';
                    this.$forceUpdate();
                    clearInterval(this.timer)
                    return;
                }
                this.sendCode = time + 's 后重新发送验证码';
                console.log('秒',this.sendCode);
                this.$forceUpdate();
            }, 1000)

        },

        //旧用户绑定获取验证码
        sendMsg(){
            let that = this;
            let data = {
                openId:context.OpenId,
                phoneNum:store.state.msgVerify.register.phoneNum,
                areaCode: store.state.msgVerify.register.areaCode
            };
            console.log('data',data);
            this.config.server(
                "/Send/Message",
                "POST",
                data,
                (data)=> {
                    console.log('success',data);
                    console.log(data);
                    that.isSendSMS = data.records[0].isSendSMS;
                    if(!that.isSendSMS){
                        that.newtime = data.records[0].lockTime;
                        this.popshow = true;
                        clearInterval(this.timer);
                        this.timer = null;
                        this.sendCode = '重新发送验证码';
                    }
                    this.$forceUpdate();

                },
                (error)=> {
                    console.log('error',error);
                },
            )

        }

    },
    //清除定时器
    beforeDestroy() {
        clearInterval(this.timer);
        this.timer = null;
    },
    created:function(){
        console.log('created');
        this.hintbox = '';
        this.sendCode = '重新发送验证码';
        this.errorshow = false;
        this.verifycode = '';
        this.timer = '';
        this.popshow = false;
        // this.sendTimer();
        this.$forceUpdate();
        //判断用户是注册还是绑定
        console.log('data',store.state.msgVerify.register);
        if(store.state.msgVerify.register.type === 'new'){
            this.getCode();
        }else{
            this.sendMsg();
        }

    },
    activated:function(){
        console.log('activated');


    },
    beforeCreate(){
        console.log('path',sessionStorage.getItem('path'));
        if(sessionStorage.getItem('path') === 'personInfo'){
            WeixinJSBridge.call('closeWindow');
        }
    }
}
</script>
<style scoped>
  .msgVerify{
    height: 100%;
  }
  .before{
    content: "";
    width: 100%;
    height: 2px;
    position: absolute;
    -webkit-transform: translate3d(0, 60%, 0);
    transform: translate3d(0, 60%, 0);
    background-color: #827159;
    right: 1px;
    bottom: -2px;
  }
  .pop .pop_confirmBox button, .pop .pop_confirmBox a{
    width: 100%;
  }
  .pop_info{
    overflow: hidden;
  }
</style>
